%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%
%%% David Escobar Sanabria
%%% descobar@aem.umn.edu
%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function [] =compDoublePlot( simSignal, simRef, simTime,simOther, ...
    testSignal, testRef, testTime, testOther, offset, name, otherNames ,Ts)

%% 
% allow repeatable runs for plots color generation.
rand('state',42)
randn('state',42)

%% Get extracted signals from flight test data 
[ t0 , n0 , nf , tf] = getDouble( testRef, testTime );

Ts_data=0.02;

%% Extra samples for visualization after the end and before the beggining of 
%  a  command sequence
deltaSamples=150;


k0=1;
kf=1;
flag=true;
i=1;

% Take the doublet part of the simulation signal
while(flag==true)
    
    if( norm( simRef(i) ) >0 && k0 ==1)
        k0=i;
    else
        
        if(i>2 && k0~=1 && simRef(i)==0 && simRef(i-2) ==0)
            kf=i;
            flag=false;
            
        end
    end
    
    i=i+1;
    if(i>= size(simRef,1))
        break;
    end
end


if(k0>deltaSamples && n0(1)>deltaSamples)
    k0=k0-deltaSamples;
    n0=n0-deltaSamples;
    t0=t0-deltaSamples*Ts;
end

if(size(simRef,1) > kf+deltaSamples && nf(end) > kf+deltaSamples)
    kf=kf+deltaSamples;
    nf=nf+deltaSamples;
    tf=tf+deltaSamples*Ts;
end


time=[0:Ts:0+Ts*(kf-k0)];

nSubplots= size(simOther,2) +1;
plotsPerFigure=2;

nSignals=size(n0,2);


figure;

subplot(plotsPerFigure,1,1);
grid on, hold on
plot(time, simRef(k0:kf)+offset,'r' , 'LineWidth', 2)
            %subplot(3,1,2);
plot(time, simSignal(k0:kf)+offset,'k' ,'LineWidth' , 2);

%subplot(3,1,3);
dRGB=1/nSignals;
r=dRGB;
g=0;
b=0;
for i=1:nSignals-1 
    %plot(timeSignal(n0(i):nf(i))-t0(i), pitchRef(n0(i):nf(i)),'r')
    
    % Plots
    randColor = rand(1,3);
   
    plot(testTime(n0(i):nf(i))-t0(i), testSignal(n0(i):nf(i)), 'Color',randColor);
    %figure;
    plot(testTime(n0(i):nf(i))-t0(i), testRef(n0(i):nf(i)), 'Color','r');
end



title(['Simulated & flight data for: ' name])
xlabel('time [s]'), ylabel(name)
%%legend(['Reference ' name],['Simulted ' name],['Flight data ' name] )
legend(['Reference ' name],['Simulted ' name] );

%% Plots of other signals:

subplotCounter=2;
global fig;
for i = 1: size(simOther,2)  
      
    subplot(plotsPerFigure,1,subplotCounter);
    grid on; hold on;
    plot(time, simOther(k0:kf,i),'k' ,'LineWidth' , 2);
    
    for j=1: size(n0,2)-1
        randColor = rand(1,3);     
        plot(testTime(n0(j):nf(j))-t0(j), testOther(n0(j):nf(j),i), 'Color',randColor);
    end
    
    title(['Simulated & flight data for: ' otherNames(i,:)]);
    xlabel('time [s]'), ylabel(otherNames(i,:))
    legend(['Simulated ' otherNames(i,:)] );
    subplotCounter=subplotCounter+1;
    if( mod(i+1,plotsPerFigure)==0 )
        
        %print (gcf,'-depsc2' , ['fig' num2str(fig) '.eps'])
        subplotCounter=1;
        fig=fig+1;
        figure;    
    else
        if(i==size(simOther,2) )
            %print (gcf,'-depsc2' , ['fig' num2str(fig) '.eps'])
        end
    end
    
end


end  % End of function
