/******************************************************************************
* FILE: misc.c
* DESCRIPTION:
*
*
*
* SOURCE:
* LAST REVISED: 5/11/05 Jung Soon Jang
*
 * University of Minnesota 
 * Aerospace Engineering and Mechanics 
 * Copyright 2011 Regents of the University of Minnesota. All rights reserved.
 *
* $Id: misc.c 332 2011-04-14 18:43:14Z murch $
******************************************************************************/

#include <time.h>

double get_time_interval(short id)
{
	struct timespec		ts;
        static struct timespec  ts_p[5];
        double 			nsec,elapsed;

        clock_gettime(CLOCK_REALTIME, &ts);
        nsec    = ts.tv_nsec- ts_p[id].tv_nsec;
        elapsed = nsec*1.0e-9;

        if(elapsed <=0) elapsed =0.0;
        ts_p[id]= ts;

        return elapsed;
}

double get_Time()
{
  	struct timespec t,tset;
        double tnow;
        static short init=0;

        if(init==0) {
           init = 1;
           tset.tv_sec = 0;
           tset.tv_nsec = 0;
           clock_settime(CLOCK_REALTIME,&tset);
           return 0.0;
        }
	clock_gettime(CLOCK_REALTIME, &t);
        tnow = t.tv_sec + 1.0e-9*(double)t.tv_nsec;
        return tnow;
}

double timenow (void)
{
	double tnow;
	struct timespec t;
	clock_gettime(CLOCK_REALTIME, &t);

	tnow = t.tv_sec + 1.0e-9*(double)t.tv_nsec;
	return tnow;
}
