/*
 * serial_mpc5200.c
 *
 *  Created on: Jun 25, 2010
 *      Author: rohit
 *
 * University of Minnesota 
 * Aerospace Engineering and Mechanics 
 * Copyright 2011 Regents of the University of Minnesota. All rights reserved.
 *
 * $Id: serial_mpc5200.c 332 2011-04-14 18:43:14Z murch $
 */

#ifndef SERIAL_MPC5200_C_
#define SERIAL_MPC5200_C_

#include "serial_mpc5200.h"


/***************************************************************************
 * Open and configure serial port
 ***************************************************************************/
int open_serial(char* serial_port,int baudrate)
{
	int fd;
	struct termios tio_serial;

	/* open serial port */
	fd = open(serial_port, O_RDWR | O_NOCTTY | O_NONBLOCK);

#ifdef mutex_sPort0
	if (fd == -1) {
		//	fprintf(stderr,"open serial: unable to open %s - %s\n",	serial_port, strerror(errno));
		pthread_mutex_lock(&mutex_sPort0);
		sprintf(&msg[3],"<FAIL>open_serial():%s-%s",serial_port, strerror(errno));
		write(sPort0, msg, sizeof(msg));
		pthread_mutex_unlock(&mutex_sPort0);
		exit(-1);
	}
#else
	if (fd == -1) {
			fprintf(stderr,"open serial: unable to open %s - %s\n",	serial_port, strerror(errno));
			exit(-1);
		}
#endif

	/* Serial port setting */
	bzero(&tio_serial, sizeof(tio_serial));
	tio_serial.c_cflag = CS8 | CLOCAL | CREAD;
	tio_serial.c_iflag = IGNBRK | IGNPAR;
	tio_serial.c_oflag = 0;

	cfsetispeed(&tio_serial, baudrate);
	cfsetospeed(&tio_serial, baudrate);

	/* Flush buffer; parameters take effect immediately */
	tcflush(fd, TCIOFLUSH);
	tcsetattr(fd, TCSANOW, &tio_serial);

	return (fd);
}
/************************* end initiallize serial port *******************/

#endif
